% Subroutine: calculate population moments given mixture parameters, called by plot_PrPost.m

% Loop over (lambda_i,y*_i0)
for i_het = 1:n_het
    m_draw = M_draw(:,:,i_het);
    v_draw = V_draw(:,:,i_het,i_het);
    
    % Non-central moments
    m1_draw = sum(m_draw.*p_draw,2);
    m2_draw = sum((m_draw.^2+v_draw).*p_draw,2);
    m3_draw = sum((m_draw.^3+3*m_draw.*v_draw).*p_draw,2);
    m4_draw = sum((m_draw.^4+6*m_draw.^2.*v_draw+3*v_draw.^2).*p_draw,2);
    
    % Central moments
    mu2_draw = m2_draw-m1_draw.^2;
    mu3_draw = m3_draw-3*m1_draw.*m2_draw+2*m1_draw.^3;
    mu4_draw = m4_draw-4*m1_draw.*m3_draw+6*m1_draw.^2.*m2_draw-3*m1_draw.^4;
    
    % Standardized skewness and kertosis
    stat_draw(:,1:end-1,i_het,i_dist) = [m1_draw, sqrt(mu2_draw), mu3_draw./mu2_draw.^(3/2), ...
        mu4_draw./mu2_draw.^2];
end

% Correlation
cov_draw = sum((prod(M_draw,3)+V_draw(:,:,1,2)).*p_draw,2)-prod(stat_draw(:,1,:,i_dist),3);
stat_draw(:,end,1,i_dist) = cov_draw./prod(stat_draw(:,2,:,i_dist),3);
stat_draw(:,end,2,i_dist) = stat_draw(:,end,1,i_dist);
    % duplicate correlation in both lambda_i and y*_i0 dimensions