% Subroutine: calculate nubmers of modes given mixture parameters, called by plot_PrPost.m

for i_draw = 1:NN_draw
    % Display iteration
    if mod(i_draw,100) == 0
        disp([smpl ': ' dist_names{i_dist} ', i_draw = ' num2str(i_draw)])
    end
    
    % Evaluate p(lambda_i,y*_i0) on the grid
    p_lambday0_K = nan(n_grid^2,K);
    for k = 1:K
        p_lambday0_K(:,k) = mvnpdf(lambday0_gridvec,M_draw(:,k,i_draw)',V_draw(:,:,k,i_draw));
    end
    p_lambday0 = reshape(p_lambday0_K*p_draw(i_draw,:)',n_grid,n_grid);
    
    % Find candidates for local maxima
    p_lambday0_tol = p_lambday0+1e-10; % tol = 1e-10 for local maxima
    is_localmax = zeros(n_grid);
    for i = 1:n_grid
        for j = 1:n_grid
            aux_ij = p_lambday0_tol(max(i-1,1):min(i+1,n_grid),max(j-1,1):min(j+1,n_grid));
            aux_ij(2-(i==1),2-(j==1)) = 0;
            is_localmax(i,j) = p_lambday0(i,j)>max(aux_ij(:));
        end
    end
    
    % Elimate duplicates by clustering locations and values of local maxima
    if sum(is_localmax(:)) > 0
        is_localmax = logical(is_localmax);
        [col_localmax,row_localmax] = find(is_localmax);
        p_localmax = p_lambday0(is_localmax);
        p_localmax = p_localmax*n_grid/max(p_localmax); 
            % normalize p_localmax to have the same scale as col_localmax and row_localmax
        
        nmode_draw(i_draw,i_dist) = max(dbscan([p_localmax row_localmax col_localmax],...
            sqrt(3)*10,1)); % search radius = sqrt(dim) * 10, minimum number of neighbors = 1
    end
end