function [sfcstPtwise_stat, sfcstAvg_stat, dfcst_stat, param_est] = ...
    pool_linear(Y,draws,param0,save_file)
%% Input: Y
YY = Y(1:end-1,:);
[T1,N] = size(YY);
T = T1-1;
ix0 = find(Y(end,:)==0);
ix1 = find(Y(end,:)~=0);

%% Input: X
n_coef = 1;

%% Input: numbers of draws
B_draw = draws(1);
N_draw = draws(2);

%% Input: tuning parameters for prior
ttau = param0{2};

%% Prepare: prior parameters 
% rho, sigma2
M_coef0 = zeros(n_coef+1,1);
V_coef0 = ttau*eye(n_coef+1);
a_ssigma20 = 3;
b_ssigma20 = mean(var(YY,1))*(a_ssigma20-1);

%% Prepare: initial values 
% y*
YY_star = YY;

% rho, lambda, sigma2
Ys = YY_star(2:end,:);
Xs(:,:,1) = YY_star(1:end-1,:);

vecX = [reshape(Xs,N*T,n_coef) ones(N*T,1)];
M_coef1 = (vecX'*vecX)\(vecX'*Ys(:));
rrho = M_coef1(1:n_coef);
llambda = M_coef1(end);
ssigma2 = var(Ys(:)-vecX*M_coef1);

%% Prepare: save draws
m_draw = nan(B_draw+N_draw,N);
s_draw = nan(B_draw+N_draw,N);

param_draw = nan(B_draw+N_draw,n_coef+2);

%% Gibbs sampler
for i_draw = 1:(B_draw+N_draw)
    %% Display iteration
    if mod(i_draw,100) == 0
        disp([save_file{2} ': i_draw = ' num2str(i_draw)])
    end
    
    %% Draw rho, lambda, sigma2 
	Ys = YY_star(2:end,:);
    Xs(:,:,1) = YY_star(1:end-1,:);
 
    vecX = [reshape(Xs,N*T,n_coef) ones(N*T,1)];
    V_coef1 = eye(n_coef+1)/(vecX'*vecX/ssigma2+eye(n_coef+1)/V_coef0);
    M_coef1 = V_coef1*(vecX'*Ys(:)/ssigma2+V_coef0\M_coef0);
    coef1 = chol(V_coef1)'*randn(n_coef+1,1)+M_coef1;
    rrho = coef1(1:n_coef);
    llambda = coef1(end);
    
    a_ssigma21 = a_ssigma20+N*T/2;
    b_ssigma21 = b_ssigma20+(Ys(:)-vecX*coef1)'*(Ys(:)-vecX*coef1)/2;
    ssigma2 = 1/gamrnd(a_ssigma21,1/b_ssigma21);
    
    %% Prepare: forecast evaluation
    m_draw(i_draw,:) = YY_star(end,:)*rrho+llambda;
    s_draw(i_draw,:) = sqrt(ssigma2);
    
    %% Save draws
    param_draw(i_draw,:) = [rrho' llambda ssigma2];  
end

%% Forecast evaluation
fcst_eval;

%% Common parameter estimates
param_est = reshape([mean(param_draw(ix_out,:)); quantile(param_draw(ix_out,:),[.05 .95])],1,[]);
