% Evaluate forecast performance of various predictors

ix_out = B_draw+(1:N_draw);
Y1_draw = max(randn(B_draw+N_draw,N).*s_draw+m_draw,0);
PY1_0_draw = normcdf(-m_draw./s_draw);

%% Prepare: set forecasts
sig0 = 0.1;

thin = 1;
N_thin = N_draw/thin;
ix_thin = ix_out(1:thin:end);

n_sfcst = 7;
is_stat_only = 1; % only report forecast evaluation statistics

sub_sfcst_triple; % subroutine: simulate triple (y_{i,T+h}^(j), pi_i^(j), W_i^(j))

%% Set forecasts: targeting average covergage probability
sub_sfcstAvg; % subroutine: set forecasts targeting average covergage probability

%% Set forecasts: targeting pointwise covergage probability
sub_sfcstPtwise; % subroutine: set forecasts targeting pointwise covergage probability

%% Density forecasts
pY1_draw = nan(B_draw+N_draw,N);
pY1_draw(:,ix0) = normcdf(-m_draw(:,ix0)./s_draw(:,ix0));
pY1_draw(:,ix1) = normpdf(Y(end,ix1),m_draw(:,ix1),s_draw(:,ix1));
lps = mean(log(mean(pY1_draw(ix_out,:))));

Y1_draw_aux = sort(Y1_draw(ix_out,:));
crps = mean(mean(abs(Y1_draw_aux-Y(end,:))-Y1_draw_aux.*((1:N_draw)'*2-N_draw-1)/N_draw));
dfcst_stat = [lps crps];